/// VM Cloud Init configuration
///
/// RedHat documentation: https://docs.redhat.com/fr/documentation/red_hat_enterprise_linux/9/html/configuring_and_managing_cloud-init_for_rhel_9/configuring-cloud-init_cloud-content
/// cloud-localds source code: https://github.com/canonical/cloud-utils/blob/main/bin/cloud-localds
#[derive(Clone, Debug, serde::Serialize, serde::Deserialize, Default)]
pub struct CloudInitConfig {
    attach_config: bool,
    /// Main user data
    user_data: String,
    /// Instance ID, set in metadata file
    #[serde(skip_serializing_if = "Option::is_none")]
    instance_id: Option<String>,
    /// Local hostname, set in metadata file
    #[serde(skip_serializing_if = "Option::is_none")]
    local_hostname: Option<String>,
    /// Network configuration
    #[serde(skip_serializing_if = "Option::is_none")]
    network_configuration: Option<String>,
}
